--with trace
--trace(1)
include machine.e
global atom s
s = 10
global atom err
err = power(2,-s)
sequence bits
atom k

function Witness(atom a, atom n)
    atom x,d
    d = 1
    x = 1
    for i = k to 1 by -1 do
        if d = 1 and x != 1 and x != n-1 then
	    return 1
        end if
        if bits[i] = 1 then
	    d = remainder(d*a,n)
        end if
        x = d
        d = remainder(d*d,n)
    end for
    if d != 1 then
        return 1
    end if
    return 0
end function

global function Is_Prime(integer n) --Miller - Rabin method
    atom a
    if integer(n/2) or remainder(n,5) = 0 then
        return 0
    end if
    bits = int_to_bytes(n-1)
    bits[1] = int_to_bits(bits[1],8)
    bits[2] = int_to_bits(bits[2],8)
    bits[3] = int_to_bits(bits[3],8)
    bits[4] = int_to_bits(bits[4],8)
    bits = bits[1]&bits[2]&bits[3]&bits[4]
    k = length(bits)
    for j = 1 to s do
        a = rand(n-1)
        if Witness(a,n) = 1 then
	    return 0
        end if
    end for
    return 1
end function
--atom x,y,t,v
--t = open("C:\\test123456.txt","w")
--x = 41
--v = 1
--while x < power(2,30) do
--    y = Is_Prime(x)
--    if y != 1 then
--    printf(1,"%d ",x-1000*(floor(x/1000)))
--    printf(t,"%d",x-1000*(floor(x/1000)))

--    end if

--    x = x+2*v
--    v = v+1
--end while

