global constant e = 2.718281828
global constant pi = 3.1415926535897932384626433832795028841
global constant inf = power(10,308)*9
global constant nan = -inf/inf

global function log_n(atom x,atom n)
    if  n <= 0 then
        return nan
    else
        return log(x)/log(n)
    end if
end function
global function mod(atom a)
    if a < 0 then
        return -1
    elsif a = 0 then
        return 0
    else
        return 1
    end if
end function
global function E(atom n)
    return power(e,n)
end function
global function ln(atom x)
    return log_n(x,e)
end function
global function sec(atom x)
    return 1/cos(x)
end function
global function cosec(atom x)
    return 1/sin(x)
end function
global function cot(atom x)
    return 1/tan(x)
end function
global function e_(atom x)
   return power(e,x)
end function
global function sinh(atom x)
    return (e_(x)-e_(-x))/2
end function
global function cosh(atom x)
    return (e_(x)+e_(-x))/2
end function
global function tanh(atom x)
    return sinh(x)/cosh(x)
end function
global function sech(atom x)
    return 1/cosh(x)
end function
global function cosech(atom x)
    return 1/sinh(x)
end function
global function coth (atom x)
    return 1/tanh(x)
end function

